/* Problem URL: https://codeforces.com/edu/course/2/lesson/5/4/practice/contest/280801/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    int prev = n;

    if (n > 1) {
        n = 1 << (32 - __builtin_clz(n - 1));
    }

    vl seg(n * 2);
    V<pair<ll, ll>> lazy(n * 2, {0, 1e5});
    V<bool> upd(n * 2);

    auto propagate = [&](int i) {
        if (!upd[i]) {
            return;
        }

        upd[i] = false;

        rmax(seg[i], lazy[i].first);
        rmin(seg[i], lazy[i].second);

        if (i < n) {
            rmax(lazy[i * 2].first, lazy[i].first);
            rmin(lazy[i * 2].second, lazy[i].second);
            if (lazy[i * 2].first > lazy[i * 2].second) {
                if (lazy[i * 2].first == lazy[i].first) {
                    lazy[i * 2].second = lazy[i * 2].first;
                } else {
                    lazy[i * 2].first = lazy[i * 2].second;
                }
            }
            upd[i * 2] = true;
            rmax(lazy[i * 2 + 1].first, lazy[i].first);
            rmin(lazy[i * 2 + 1].second, lazy[i].second);
            if (lazy[i * 2 + 1].first > lazy[i * 2 + 1].second) {
                if (lazy[i * 2 + 1].first == lazy[i].first) {
                    lazy[i * 2 + 1].second = lazy[i * 2 + 1].first;
                } else {
                    lazy[i * 2 + 1].first = lazy[i * 2 + 1].first;
                }
            }
            upd[i * 2 + 1] = true;
        }

        lazy[i] = {0, 1e5};
    };

    function<void(int, int, int, int, int, int, ll)> update = [&](int i, int l, int r, int tl, int tr, int t, ll v) {
        propagate(i);

        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            if (t) {
                lazy[i].second = v;
            } else {
                lazy[i].first = v;
            }
            upd[i] = true;
            propagate(i);
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, t, v);
        update(i * 2 + 1, mid + 1, r, tl, tr, t, v);
    };

    function<ll(int, int, int, int)> query = [&](int i, int l, int r, int t) {
        propagate(i);

        if (i >= n) {
            return seg[i];
        }

        int mid = (l + r) >> 1;

        if (mid >= t) {
            return query(i * 2, l, mid, t);
        }
        return query(i * 2 + 1, mid + 1, r, t);
    };

    while (k--) {
        int op, l, r, h;
        cin >> op >> l >> r >> h;

        update(1, 0, n - 1, l, r, op - 1, h);
    }

    rep(i, prev) {
        cout << query(1, 0, n - 1, i) << '\n';
    }
}
